; WINDOWS XP FAT12 (& FAT16) BOOT SECTOR SOURCE CODE
; by Erdogan Tan - 16 December 2017
; Disassembler: IDA Pro Free by Hex-Rays SA

; Last Modification: 17/12/2017

; ---------------------------------------------------------------------------
; 	This file is generated by The Interactive Disassembler (IDA)	    
; 	Copyright (c) 2010 by Hex-Rays SA, <support@hex-rays.com>	    
; 			 Licensed to: Freeware version			    
; ---------------------------------------------------------------------------
; File Name   :	windows_xp_fat12_bs.bin

		.386
		.model flat

; ---------------------------------------------------------------------------

; Segment type:	Regular
seg000		segment	byte public '' use16
		assume cs:seg000
		assume es:nothing, ss:nothing, ds:nothing, fs:nothing, gs:nothing
; ---------------------------------------------------------------------------
BS_jmpBoot:
		jmp	short loc_3E
		nop	; db 90h
; ---------------------------------------------------------------------------
BS_OEMName:
		db	'MSDOS5.0'	; bp+3
BPB_BytesPerSec: dw	512		; bp+11
BPB_SecPerClus:	db	4		; bp+13
BPB_RsvdSecCnt: dw	8		; bp+14
BPB_NumFATs:	db	2		; bp+16
BPB_RootEntCnt:	dw	512		; bp+17
BPB_TotSec16:	dw	16320		; bp+19
BPB_Media:	db	0F8h		; bp+21
BPB_FATSz16:	dw	12		; bp+22
BPB_SecPerTrk:	dw	63		; bp+24
BPB_NumHeads:	dw	4		; bp+26
BPB_HiddSec:	dd	1		; bp+28
BPB_TotSec32:	dd	0		; bp+32
BS_DrvNum:	db	80h		; bp+36
BS_Reserved1:	db	0		; bp+37
BS_BootSig:	db	29h		; bp+38
BS_VolID:	dd	2CDB4892h	; bp+39
BS_VolLab:	db	'NO NAME    '	; bp+43
BS_FilSysType:	db	'FAT12   '	; bp+54
; ---------------------------------------------------------------------------

loc_3E:
		xor	cx, cx
loc_40:
		mov	ss, cx
		mov	sp, 7BF0h
		mov	ds, cx
		mov	ax, 2000h
		mov	es, ax
		assume es:nothing
loc_4C:
		cld
		mov	bp, 7C00h
		cmp	[bp+24h], cl ;0	; [BS_DrvNum]
		jge	short loc_79	; floppy disk
		mov	ax, cx
		cwd
loc_58:	
		; Check masterboot sector for Partition ID
		; Read masterboot sector (DX_AX = 0)
		call	ReadSector	; sub_197
		jb	short loc_79	; error 
		sub	bx, 3Ah		; 200h - 3Ah = 1C6h (1BEh+8)
					; Partition table row + 8
					; (= Start Sector, LBA)
		mov	eax, ds:7C1Ch	; [BPB_HiddSec]
loc_64:
		cmp	eax, es:[bx]	; Partition Start = [BPB_HiddSec]
		mov	dl, es:[bx-4]	; Partition Type (PT row + 4)
		jnz	short loc_74	; =! not same partition
		or	dl, 2		; OR result = 0Eh or another !? 
		mov	[bp+2],	dl	; [BS_jmpBoot+2]
					; NOTE: According to this (*)
					; Microsoft FAT BS code, FAT12 LBA
					; partition and FAT16 LBA partition
					; must have same '0Eh' type ID.
					; (0Ch is FAT32 LBA partition ID.)
loc_74:
		add	bl, 10h		; BX points to the next PT row
		jnb	short loc_64	; check the next partition
					; (till the partition table row 4)
loc_79:
		xor	cx, cx
		mov	al, [bp+10h]	; [BPB_NumFATs]
		cbw
		mul	word ptr [bp+16h] ; [BPB_FATSz16]
		add	ax, [bp+1Ch]	; word [BPB_HiddSec]
		adc	dx, [bp+1Eh]	; word [BPB_HiddSec+2]
		add	ax, [bp+0Eh]	; [BPB_RsvdSecCnt]
		adc	dx, cx
		mov	si, [bp+11h]	; [BPB_RootEntCnt]
		pusha
		mov	[bp-4],	ax	; [7BFCh] = Root Dir address
		mov	[bp-2],	dx
		mov	ax, 20h	; 32	; Directory Entry Size
		mul	si
		mov	bx, [bp+0Bh]	; [BPB_BytesPerSec] =  512
		add	ax, bx		
		dec	ax
		div	bx
		; AX =	Root directory sectors
		add	[bp-4],	ax	; [7BFCh]  = Start of Data area 
		adc	[bp-2],	cx  	; adc [bp-2], 0
		popa
loc_AB:
		mov	di, 0		; Root dir entry offset
		; DX_AX = sector address (DX = 0)
		; CX = 0 (sector count - 1)
		call	ReadSector	; call sub_197
		jb	short loc_EC
		; DX_AX = to next root directory sector
loc_B3:
		cmp	es:[di], ch	; 0 ?
		jz	short loc_CF	; yes ('NTLDR' not found)
		pusha
		mov	cl, 0Bh		; 11	
		mov	si, loc_1A1h	; 7DA1h ('NTLDR   ')
		repe	cmpsb
		popa
		jz	short loc_F5	; NTLDR found
		dec	si
		jz	short loc_CF	; all entries have been searched
		add	di, 20h	; 32	; next dir entry
		cmp	di, bx		; end of root dir buffer
		jb	short loc_B3
		jmp	short loc_AB	; read next root dir sector
; ---------------------------------------------------------------------------

loc_CF:
		; NTLDR not found eror
		;
		mov	al, ds:7DFBh	; Low byte of error message address
loc_D2:
		mov	ah, 7Dh		; High byte of error message address		
		mov	si, ax		; 7DCDh, 'Disk error' message
loc_D6:
		lodsb
		cbw
		inc	ax		; FFFFh = 0
		jz	short loc_E7	; next row: 'press any to restart'
		dec	ax		; 0 = FFFFh
		jz	short loc_F1
		mov	ah, 0Eh
		mov	bx, 7
		int	10h	; - VIDEO - TTY WRITE
				; AL = character, BH = display page
				; BL = foreground color	(graphics modes)
		jmp	short loc_D6
; ---------------------------------------------------------------------------

loc_E7:
		mov	al, ds:7DFDh	; low byte of
		jmp	short loc_D2	; 'press any to restart' msg offset	
; ---------------------------------------------------------------------------

loc_EC:
		mov	al, ds:7DFCh	; low byte of
		jmp	short loc_D2	; 'disk error' msg offset
; ---------------------------------------------------------------------------

loc_F1:		; wait for a keystroke and then reboot
		int	16h		; KEYBOARD -
		int	19h		; DISK BOOT
					; causes reboot	of disk	system

loc_F5:
		mov	dx, es:[di+1Ah] ; First cluster number of 'NTLDR' 
		push	dx
		mov	al, 1		; Only one sector !
					; (Not sectors per cluster..)
		mov	bx, 0		; Buffer offset = 0
		call	ReadCluster	; call sub_13D
		jb	short loc_EC	; Disk error
		pop	bx		; BX = 1st cluster num of 'NTLDR'
		mov	dl, [bp+24h]	; [BS_DrvNum]
		mov	si, 7C0Bh	; BPB_BytesPerSec address
					; NTLDR will use this
					; addres for 
					; byte [si+2]* word [si]
					; = bytes per cluster
		mov	di, sp
			; put address of ReadFileSector (sub_13D) into
			; 7BF0h.
			; NTLDR (sub routine from NTLDR offset 3, jump)
			; (SubRoutine in NTLDR offset 4Bh for Windows XP)
			; will use ReadFileSector for loading it's other
			; sectors at memory. This address will be
			; transferred to NTLDR in DI register.

		mov	word ptr [bp-10h], 7D3Dh  ; address of 'sub_13D' 
			; put 'get next cluster' code addr into 7BF4h 
		mov	word ptr [bp-0Ch], 7D29h  ; address of 'loc_129' 	
		mov	cx, ds
		mov	[bp-0Eh], cx	; [7BF2h], data seg for 'sub_13D'
		mov	[bp-0Ah], cx    ; [7BF6h], data seg for 'loc_129' 
			; change 'retn' instruction at locret_196 (7D97h)
			; to 'retf'. (Because CS will be 2000h in NTLDR)
		mov	byte ptr ds:7D96h, 0CBh
		jmp	far ptr	2000h:3 ; Jump to NTLDR file Offset 3.
					; (Note: This jump addres is NTLDR
					; file Offset 0 for FAT32 BS code.)
; ---------------------------------------------------------------------------
loc_129:
		; This code part will be used by NTLDR 
		; (This part is not used by other boot sector routines)
		movzx	cx, al        ; sector count		   	
		mov	eax, [bp-8]   ; Sector offset will be used by NTLDR		
		add	eax, [bp+1Ch] ; [BPB_HiddSec]
		mov	edx, eax
		shr	edx, 10h
		jmp	short loc_19B ; ReadSector_next	

; --------------- S U B	R O U T	I N E ---------------------------------------

sub_13D		proc near
ReadCluster:	; Read cluster (in DX) sector(s)
		movzx	cx, al		; sector count
		dec	dx
		dec	dx		; cluster number - 2
		mov	al, [bp+0Dh]	; [BPB_SecPerClus]
		xor	ah, ah
		mul	dx		; DX_AX = 1st sector addr of cluster
		add	ax, [bp-4]	; [7CFCh], Start of FAT FS data area
		adc	dx, [bp-2]	
		jmp	short loc_19B	; ReadSector_next (read NTLDR file)
sub_13D		endp

; ---------------------------------------------------------------------------
; START	OF FUNCTION CHUNK FOR sub_197

loc_151:
ReadSector_x:	push	dx
		push	ax
		push	es
		push	bx
		push	1
		push	10h
		xchg	ax, cx
		mov	ax, [bp+18h] ; [BPB_SecPerTrk]
		xchg	ax, si
		xchg	ax, dx
		xor	dx, dx
		div	si
		xchg	ax, cx
		div	si
		inc	dx
		xchg	cx, dx
		div	word ptr [bp+1Ah] ; [BPB_NumHeads]
		mov	dh, dl
		mov	ch, al
		ror	ah, 2
		or	cl, ah
		mov	ax, 201h
		cmp	byte ptr [bp+2], 0Eh ; (*) ; [BS_jmpBoot+2]
		jnz	short loc_182	; Not a LBA disk/partition
		mov	ah, 42h	; 'B'
		mov	si, sp		; Disk address packet
loc_182:
		mov	dl, [bp+24h]	; [BS_DrvNum]
		int	13h		; DISK -
		popa
		popa
		jb	short locret_196 ; return with error
		inc	ax
		jnz	short loc_18F
		inc	dx
loc_18F:
		add	bx, [bp+0Bh]	; [BPB_BytesPerSec] = 512
		dec	cx
		jnz	short ReadSector_next ; loc_19B 
		clc
locret_196:
		retn

; END OF FUNCTION CHUNK	FOR sub_197

; --------------- S U B	R O U T	I N E ---------------------------------------

sub_197		proc near
ReadSector:

; FUNCTION CHUNK AT 0151 SIZE 00000046 BYTES

		inc	cx
		mov	bx, 0
loc_19B:
ReadSector_next:
		pusha
		push	large 0
		jmp	short ReadSector_x ; loc_151
sub_197		endp

; ---------------------------------------------------------------------------
startup_file:
loc_1A1: 				; 7DA1h		
		db	'NTLDR   '	; NT LOADER file (Windows OS loader)
loc_1AC:
replace_disk_msg:
		db	0Dh, 0Ah
                db      'Disk veya baka ortam karn.'
			; 'Remove disks or other media.'
		db	0FFh
loc_1CD:
disk_error_msg:
		db	0Dh, 0Ah
		db	'Disk hatasi'
			; 'Disk error'
		db	0FFh
loc_1DB:
press_key_start_msg:
		db	0Dh, 0Ah
		db	'Baslatmak icin tusa basin'
			; 'Press any key to restart' 	
		db	0Dh, 0Ah, 0
loc_1F9: 				; 7DF9h
		db	0
loc_1FA:				; 7DFAh
		db	0		 
loc_1FB: 				; 7DFBh
		db	0ACh ; replace disk msg offset (1ACh)	
loc_1FC:				; 7DFCh
		db	0CDh ; disk error msg offset (1CDh)
loc_1FD:				; 7DFDh	
		db	0DBh ; press any key msg offset (1DBh)	
boot_sector_sign:
		db	55h
		db	0AAh

seg000		ends

		end